"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class PedigreeMember(ProtocolElement):
    """
    This defines a RD Participant (demographics and pedigree information)
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "sex",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import participant as participant_1_1_2

        return {
            "ancestries": participant_1_1_2.Ancestries,
            "consentStatus": participant_1_1_2.ConsentStatus,
            "disorderList": participant_1_1_2.Disorder,
            "hpoTermList": participant_1_1_2.HpoTerm,
            "inbreedingCoefficient": participant_1_1_2.InbreedingCoefficient,
            "samples": participant_1_1_2.Sample,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import participant as participant_1_1_2

        return {
            "adoptedStatus": participant_1_1_2.AdoptedStatus,
            "affectionStatus": participant_1_1_2.AffectionStatus,
            "consanguineousParents": participant_1_1_2.TernaryOption,
            "lifeStatus": participant_1_1_2.LifeStatus,
            "monozygotic": participant_1_1_2.TernaryOption,
            "participantQCState": participant_1_1_2.ParticipantQCState,
            "personKaryotypicSex": participant_1_1_2.PersonKaryotipicSex,
            "sex": participant_1_1_2.Sex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import participant as participant_1_1_2

        return {
            "org.gel.models.participant.avro.AdoptedStatus": participant_1_1_2.AdoptedStatus,
            "org.gel.models.participant.avro.AffectionStatus": participant_1_1_2.AffectionStatus,
            "org.gel.models.participant.avro.Ancestries": participant_1_1_2.Ancestries,
            "org.gel.models.participant.avro.TernaryOption": participant_1_1_2.TernaryOption,
            "org.gel.models.participant.avro.ConsentStatus": participant_1_1_2.ConsentStatus,
            "org.gel.models.participant.avro.Disorder": participant_1_1_2.Disorder,
            "org.gel.models.participant.avro.HpoTerm": participant_1_1_2.HpoTerm,
            "org.gel.models.participant.avro.InbreedingCoefficient": participant_1_1_2.InbreedingCoefficient,
            "org.gel.models.participant.avro.LifeStatus": participant_1_1_2.LifeStatus,
            "org.gel.models.participant.avro.TernaryOption": participant_1_1_2.TernaryOption,
            "org.gel.models.participant.avro.ParticipantQCState": participant_1_1_2.ParticipantQCState,
            "org.gel.models.participant.avro.PersonKaryotipicSex": participant_1_1_2.PersonKaryotipicSex,
            "org.gel.models.participant.avro.Sample": participant_1_1_2.Sample,
            "org.gel.models.participant.avro.Sex": participant_1_1_2.Sex,
            "org.gel.models.participant.avro.PedigreeMember": participant_1_1_2.PedigreeMember,
        }

    __slots__ = [
        "sex",
        "additionalInformation",
        "adoptedStatus",
        "affectionStatus",
        "ancestries",
        "consanguineousParents",
        "consentStatus",
        "disorderList",
        "fatherId",
        "gelSuperFamilyId",
        "hpoTermList",
        "inbreedingCoefficient",
        "isProband",
        "lifeStatus",
        "monozygotic",
        "motherId",
        "participantId",
        "participantQCState",
        "pedigreeId",
        "personKaryotypicSex",
        "samples",
        "superFatherId",
        "superMotherId",
        "twinGroup",
        "yearOfBirth",
    ]

    def __init__(
        self,
        sex,
        additionalInformation=None,
        adoptedStatus=None,
        affectionStatus=None,
        ancestries=None,
        consanguineousParents=None,
        consentStatus=None,
        disorderList=None,
        fatherId=None,
        gelSuperFamilyId=None,
        hpoTermList=None,
        inbreedingCoefficient=None,
        isProband=None,
        lifeStatus=None,
        monozygotic=None,
        motherId=None,
        participantId=None,
        participantQCState=None,
        pedigreeId=None,
        personKaryotypicSex=None,
        samples=None,
        superFatherId=None,
        superMotherId=None,
        twinGroup=None,
        yearOfBirth=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_1_2.PedigreeMember model.

        :param sex:
            Sex of the Participant
        :type sex: Sex
        :param additionalInformation:
            We could add a map here to store additional information for example
            URIs to images, ECGs, etc         Null by default
        :type additionalInformation: None | dict[str, str]
        :param adoptedStatus:
            Adopted Status
        :type adoptedStatus: None | AdoptedStatus
        :param affectionStatus:
            Affection Status
        :type affectionStatus: None | AffectionStatus
        :param ancestries:
            Participant's ancestries, defined as Mother's/Father's Ethnic Origin
            and Chi-square test for goodness of fit of this sample to
            1000 Genomes Phase 3 populations
        :type ancestries: None | Ancestries
        :param consanguineousParents:
            The parents of this participant has a consanguineous relationship
        :type consanguineousParents: None | TernaryOption
        :param consentStatus:
            What has this participant consented to?         A participant that has
            been consented to the programme should also have sequence
            data associated with them; however         this needs to
            be programmatically checked
        :type consentStatus: None | ConsentStatus
        :param disorderList:
            Clinical Data (disorders). If the family member is unaffected as per
            affectionStatus then this list is empty
        :type disorderList: None | list[Disorder]
        :param fatherId:
            refers to the pedigreeId of the father         Id of the parent, if
            unknown then no parent is referenced. Parents may need to
            be entered even if no data is known         about them in
            order to unambiguously reconstruct the pedigree.
        :type fatherId: None | int
        :param gelSuperFamilyId:
            superFamily id, this id is built as a concatenation of all families id
            in this superfamily i.e, fam10024_fam100457
        :type gelSuperFamilyId: None | str
        :param hpoTermList:
            Clinical Data (HPO terms)
        :type hpoTermList: None | list[HpoTerm]
        :param inbreedingCoefficient:
            Inbreeding Coefficient Estimation
        :type inbreedingCoefficient: None | InbreedingCoefficient
        :param isProband:
            If this field is true, the member should be considered the proband of
            this family
        :type isProband: None | boolean
        :param lifeStatus:
            Life Status
        :type lifeStatus: None | LifeStatus
        :param monozygotic:
            A property of the twinning group but should be entered for all members
        :type monozygotic: None | TernaryOption
        :param motherId:
            refers to the pedigreeId of the mother         Id of the parent, if
            unknown then no parent is referenced. Parents may need to
            be entered even if no data is known         about them in
            order to unambiguously reconstruct the pedigree.
        :type motherId: None | int
        :param participantId:
            participantId
        :type participantId: None | str
        :param participantQCState:
            participantQCState
        :type participantQCState: None | ParticipantQCState
        :param pedigreeId:
            Numbering used to refer to each member of the pedigree
        :type pedigreeId: None | int
        :param personKaryotypicSex:
            Karyotypic sex of the participant as previously established or by
            looking at the GEL genome
        :type personKaryotypicSex: None | PersonKaryotipicSex
        :param samples:
            This is an array containing all the samples that belong to this
            individual, e.g ["LP00002255_GA4"]
        :type samples: None | list[Sample]
        :param superFatherId:
            this id is built using the original familyId and the original
            pedigreeId of the father
        :type superFatherId: None | int
        :param superMotherId:
            this id is built using the original familyId and the original
            pedigreeId of the mother
        :type superMotherId: None | int
        :param twinGroup:
            Each twin group is numbered, i.e. all members of a group of
            multiparous births receive the same number
        :type twinGroup: None | int
        :param yearOfBirth:
            Year of Birth
        :type yearOfBirth: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.1.2"
